"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var vqb = require("./");
var _ = require("lodash");
var FakeMongoToJson = /** @class */ (function () {
    function FakeMongoToJson(bsonType) {
        var params = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            params[_i - 1] = arguments[_i];
        }
        this.bsonType = bsonType;
        this.bsonType = bsonType;
        this.params = params;
    }
    FakeMongoToJson.prototype.toString = function () {
        return this.bsonType + "(" + this.params.map(function (it) {
            if (_.isUndefined(it))
                return "undefined";
            if (_.isString(it)) {
                return "\"" + it + "\"";
            }
            if (_.isFunction(it)) {
                return it.toString();
            }
            if (it instanceof FakeMongoToJson) {
                return it.toString();
            }
            return _.isObject(it) ? JSON.stringify(it) : it;
        }) + ")";
    };
    return FakeMongoToJson;
}());
exports.FakeMongoToJson = FakeMongoToJson;
function ObjectId(str) {
    return new FakeMongoToJson("ObjectId", str);
}
exports.ObjectId = ObjectId;
function BinData() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "BinData"].concat(params)))();
}
exports.BinData = BinData;
function Code() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "Code"].concat(params)))();
}
exports.Code = Code;
function ISODate() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "ISODate"].concat(params)))();
}
exports.ISODate = ISODate;
function DBRef() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "DBRef"].concat(params)))();
}
exports.DBRef = DBRef;
function NumberInt() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "NumberInt"].concat(params)))();
}
exports.NumberInt = NumberInt;
function NumberLong() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "NumberLong"].concat(params)))();
}
exports.NumberLong = NumberLong;
function MD5() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "MD5"].concat(params)))();
}
exports.MD5 = MD5;
function Symbol() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "Symbol"].concat(params)))();
}
exports.Symbol = Symbol;
function UUID() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "UUID"].concat(params)))();
}
exports.UUID = UUID;
function Timestamp() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "Timestamp"].concat(params)))();
}
exports.Timestamp = Timestamp;
function NumberDecimal() {
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    return new (FakeMongoToJson.bind.apply(FakeMongoToJson, [void 0, "NumberDecimal"].concat(params)))();
}
exports.NumberDecimal = NumberDecimal;
function stringifyReplacer(k, value, takeOnQuoted) {
    if (takeOnQuoted === void 0) { takeOnQuoted = false; }
    var requireToString = (function () {
        if (_.isRegExp(value)) {
            return true;
        }
        if (value && (value instanceof FakeMongoToJson)) {
            return true;
        }
        return false;
    })();
    if (requireToString) {
        value = value.toString();
        if (takeOnQuoted) {
            value = vqb.takeOnQuoted(value);
        }
    }
    return value;
}
exports.stringifyReplacer = stringifyReplacer;
function takeOnQuotedStringifyReplacer(k, value) {
    return stringifyReplacer(k, value, true);
}
exports.takeOnQuotedStringifyReplacer = takeOnQuotedStringifyReplacer;
var FakeMongoOpRuleClass = /** @class */ (function () {
    function FakeMongoOpRuleClass(op, value, type) {
        if (type === void 0) { type = "String"; }
        this.op = op;
        this.value = value;
        this.type = type;
    }
    FakeMongoOpRuleClass.prototype.tojson = function () {
        return "mb.regex." + _.camelCase(this.op) + "(`" + this.value + "`)";
    };
    return FakeMongoOpRuleClass;
}());
exports.FakeMongoOpRuleClass = FakeMongoOpRuleClass;
//fake mb.regex.xxxx
exports.MB_REGEX = {
    contains: function (val) {
        return new FakeMongoOpRuleClass("contains", val);
    },
    notContains: function (val) {
        return new FakeMongoOpRuleClass("not contains", val);
    },
    startsWith: function (val) {
        return new FakeMongoOpRuleClass("starts with", val);
    },
    notStartsWith: function (val) {
        return new FakeMongoOpRuleClass("not starts with", val);
    },
    endsWith: function (val) {
        return new FakeMongoOpRuleClass("ends with", val);
    },
    notEndsWith: function (val) {
        return new FakeMongoOpRuleClass("not ends with", val);
    }
};
//# sourceMappingURL=fakeMongoBsonClasses.js.map